Ruby trunk - Bug #5675

[mingw] static build fails due to socket extension build failure
11/27/2011 04:36 AM - jonforums (Jon Forums)

Status: Closed

Priority: Normal

Assignee:

Target version: 1.9.3

ruby -v: - Backport:
Description

| get the following failure on my Win7 32bit system while trying to build ruby_1_9 3@33661 The problem likely exists on
trunk@33852 but #5674 blocks me from trying to replicate.

Providing --with-out-ext=socket to ./configure is a one (undesirable) workaround. No failure when building on Arch.
C:\Users\Jon\Documents\RubyDev\ruby-git\build>sh -c "../configure --disable-shared --disable-install-doc && make"

make[2]: Entering directory /c/Users/Jon/Documents/RubyDev/ruby-git/build/ext/socket’
generating socket-i386-mingw32.def

generating constant definitions

compiling ../../../ext/socket/init.c

compiling ../../../ext/socket/constants.c

compiling ../../../ext/socket/basicsocket.c

compiling ../../../ext/socket/socket.c

.J..1..Jext/socket/socket.c: In function 'rsock_sock_s_socketpair':
./..l../ext/socket/socket.c:114:5: warning: implicit declaration of function 'socketpair’
compiling ../../../ext/socket/ipsocket.c

compiling ../../../ext/socket/tcpsocket.c

compiling ../../../ext/socket/tcpserver.c

compiling ../../../ext/socket/sockssocket.c
compiling ../../../ext/socket/udpsocket.c
compiling ../../../ext/socket/unixsocket.c
compiling ../../../ext/socket/unixserver.c
compiling ../../../ext/socket/option.c
compiling ../../../ext/socket/ancdata.c

compiling ../../../ext/socket/raddrinfo.c

linking shared-object socket.so

socket.o: In functionrsock_sock_s_socketpair':
c:\Users\Jon\Documents\RubyDev\ruby-git\build\ext\socket/../../../ext/socket/socket.c:114: undefined reference to socketpair
c:\Users\Jon\Documents\RubyDev\ruby-git\build\ext\socket/../../../ext/socket/socket.c:117: undefined reference tosocketpair'
collect2: Id returned 1 exit status

make[2]: *** [../../.ext/i386-mingw32/socket.so] Error 1

make[2]: Leaving directory /c/Users/Jon/Documents/RubyDev/ruby-git/build/ext/socket’

make[1]: *** [ext/socket/all] Error 2

make[1]: Leaving directory/c/Users/Jon/Documents/RubyDev/ruby-git/build’

make: *** [build-ext] Error 2

Associated revisions

Revision 1510ad86 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

¢ include/ruby/subst.h: moved Windows specific substitions from win32.h.
e ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33876 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 33876 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

e include/ruby/subst.h: moved Windows specific substitions from win32.h.
¢ ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

Revision 33876 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

06/26/2019 1/5



https://bugs.ruby-lang.org/issues/5674

@ include/ruby/subst.h: moved Windows specific substitions from win32.h.
¢ ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

Revision 33876 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

¢ include/ruby/subst.h: moved Windows specific substitions from win32.h.
e ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

Revision 33876 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

¢ include/ruby/subst.h: moved Windows specific substitions from win32.h.
e ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

Revision 33876 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

e include/ruby/subst.h: moved Windows specific substitions from win32.h.
¢ ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

Revision 33876 - 11/28/2011 01:36 AM - nobu (Nobuyoshi Nakada)

¢ include/ruby/subst.h: moved Windows specific substitions from win32.h.
e ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]

Revision b0381723 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

¢ win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

[Bug #5675

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33879 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 33879 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

¢ win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

Revision 33879 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

¢ win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

Revision 33879 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

e win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

Revision 33879 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

¢ win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

Revision 33879 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

¢ win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

Revision 33879 - 11/28/2011 03:15 AM - nobu (Nobuyoshi Nakada)

e win32/mkexports.rb (Exports#read_substitution): need to read from subst.h too.

Revision 1dea1927 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

e include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

e ext/socket/extconf.rb: the alternative hack for [Bug #5675].
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@33947 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 33947 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

e include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

e ext/socket/extconf.rb: the alternative hack for [Bug #5675].

Revision 33947 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

¢ include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

® ext/socket/extconf.rb: the alternative hack for [Bug #5675].

Revision 33947 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

¢ include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

¢ ext/socket/extconf.rb: the alternative hack for [Bug #5675].

Revision 33947 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

e include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

e ext/socket/extconf.rb: the alternative hack for [Bug #5675].

Revision 33947 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

e include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

¢ ext/socket/extconf.rb: the alternative hack for [Bug #5675].

Revision 33947 - 12/05/2011 05:29 AM - usa (Usaku NAKAMURA)

¢ include/ruby/{subst.h,win32.h}, ext/socket/rubysocket.h: revert
r33876. [ruby-core:41475] [Bug #5706]

¢ ext/socket/extconf.rb: the alternative hack for [Bug #5675].
History

#1 - 11/27/2011 04:23 PM - kosaki (Motohiro KOSAKI)
- ruby -v changed from ruby 1.9.3p0 (2011-11-08 revision 33661) [i386-mingw32] to -

compiling ../../../ext/socket/socket.c
../../..Jext/socket/socket.c: In function 'rsock_sock_s_socketpair':
.I../../Jext/socket/socket.c:114:5: warning: implicit declaration of function 'socketpair

This warning shouldn't be happen. But I'm wondering it because many
people did success mingw32 build. Hmm..

Luis, do you have any opinion? (note: this is head of ruby_1_9 3 branch).

#2 - 11/27/2011 06:44 PM - phasis68 (Heesob Park)

Configuring with --disable-shared option caused failure on mingw32 build.
As a workaround, inserting following 4 lines at line #12 of socket.c solves the problem.

#ifdef _WIN32

#undef socketpair

#define socketpair(a, t, p, s) rb_w32_socketpair(a, t, p, S)
#endif

#3 - 11/27/2011 11:53 PM - luislavena (Luis Lavena)

On Sun, Nov 27, 2011 at 4:11 AM, KOSAKI Motohiro
kosaki.motohiro@gmail.com wrote:

This warning shouldn't be happen. But I'm wondering it because many
people did success mingw32 build. Hmm..

Build with --enable-shared does work, but doesn't work when build with
--disable-shared.

| think Heesob's patch does the trick, will test in a little bit.

Luis Lavena
AREA 17

Perfection in design is achieved not when there is nothing more to add,
but rather when there is nothing more to take away.
Antoine de Saint-ExupA®ry

#4 - 11/28/2011 12:53 AM - kosaki (Motohiro KOSAKI)

2011/11/27 Luis Lavena luislavena@gmail.com:

On Sun, Nov 27, 2011 at 4:11 AM, KOSAKI Motohiro
kosaki.motohiro@gmail.com wrote:

This warning shouldn't be happen. But I'm wondering it because many
people did success mingw32 build. Hmm..

Build with --enable-shared does work, but doesn't work when build with
--disable-shared.
| think Heesob's patch does the trick, will test in a little bit.

Why doesn't socket.c include "ruby/win32.h"? | apologize if | ask
dumb question.

#5 - 11/28/2011 12:53 AM - luislavena (Luis Lavena)

On Sun, Nov 27, 2011 at 12:41 PM, KOSAKI Motohiro
kosaki.motohiro@gmail.com wrote:
Why doesn't socket.c include "ruby/win32.h"? A | apologize if | ask
dumb question.

Not a dumb question, a very valid one...

ruby.h includes ruby/ruby.h
ruby/ruby.h includes ruby/defines.h
ruby/defines.h does include ruby/win32.h

socket.c is including rubysocket.h which includes ruby/ruby.h, so it
should be resolving properly, right?

Luis Lavena
AREA 17

Perfection in design is achieved not when there is nothing more to add,
but rather when there is nothing more to take away.
Antoine de Saint-ExupA@ry

#6 - 11/28/2011 01:53 AM - kosaki (Motohiro KOSAKI)

Why doesn't socket.c include "ruby/win32.h"? A | apologize if | ask
dumb question.

Not a dumb question, a very valid one...

ruby.h includes ruby/ruby.h
ruby/ruby.h includes ruby/defines.h
ruby/defines.h does include ruby/win32.h

socket.c is including rubysocket.h which includes ruby/ruby.h, so it
should be resolving properly, right?

| thought so. But | can't think Jon told lie....

#7 - 11/28/2011 10:36 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed
- % Done changed from 0 to 100

This issue was solved with changeset r33876.
Jon, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

@ include/ruby/subst.h: moved Windows specific substitions from win32.h.

¢ ext/socket/rubysocket.h: include ruby/subst.h. [Bug #5675]
